local function ringassign(ring, mo)
    ring.skinchange = mo
end

local function skinchange(p)
    local skintable = {}
    for skin in skins.iterate do
        if skin.name != p.mo.skin
            table.insert(skintable, skin.name)
        end
    end
    if not p.mo.storedflags
        p.mo.storedflags = false
    end
    R_SetPlayerSkin(p, skintable[P_RandomRange(1, #skintable)])
    p.mo.color = skins[p.mo.skin].prefcolor
    if p.mo.sprite2 == 0
        p.mo.state = S_PLAY_WALK
    end
    p.mo.storedcarry = p.powers[pw_carry]
    p.mo.storedflags = p.pflags
    P_ResetPlayer(p)
    p.pflags = p.mo.storedflags
    p.powers[pw_carry] = p.mo.storedcarry
end


local function rings(ring)
    local fof = P_ThingOnSpecial3DFloor(ring)
    if fof and fof.valid
    and GetSecSpecial(fof.special, 1) == 3 -- in lava?
        ring.skinchange = nil
    end
    for p in players.iterate do
        if ring.skinchange == p.mo
            skinchange(p)
        end
    end
end

local function ringbox(ring, mo)
    for p in players.iterate do
        if p.mo == mo
        or p.mo == mo.target
            skinchange(p)
        end
    end
end

addHook("TouchSpecial", ringassign, MT_RING)
addHook("TouchSpecial", ringassign, MT_FLINGRING)
addHook("MobjDeath", rings, MT_RING)
addHook("MobjDeath", rings, MT_FLINGRING)
addHook("MobjDeath", ringbox, MT_RING_BOX)